# Custom Implementation of Titans Architecture in TensorFlow

## Overview
This repository provides a custom implementation of the Titans architecture using TensorFlow. The aim is to harness state-of-the-art neural network design principles to develop scalable and efficient deep learning models.

## Description
The repository presents an implementation based on the Titans architecture described in the paper "Titans: Learning to Memorize at Test Time". Please note that only "Memory as a Context" has been implemented, and some variations may exist compared to the paper.

## Getting Started
### Prerequisites
- Python 3.7 or later
- TensorFlow 2.x

### Installation

```bash
pip install tf-titans
```

### Usage

Refer to the example file to get started. It is recommended to use the custom training function for models that incorporate memory.

## Contributing
Contributions are welcome. Please feel free to submit issues and pull requests.

## License
This project is licensed under the MIT License. See the LICENSE file for further details.

## Contact
For inquiries or further discussion, please contact <mohammedsaajid23@gmail.com>.

## Citations

```
@inproceedings{Behrouz2024TitansLT,
    title   = {Titans: Learning to Memorize at Test Time},
    author  = {Ali Behrouz and Peilin Zhong and Vahab S. Mirrokni},
    year    = {2024},
    url     = {https://api.semanticscholar.org/CorpusID:275212078}
}
```
